/**
 * @file    GoPoint3d16s.cs
 *
 * @internal
 * Copyright (C) 2022-2023 by LMI Technologies Inc.
 * Licensed under the MIT License.
 * Redistributed files must retain the above copyright notice.
 */
namespace GoPxLSdk
{
    public class GoPoint3d16s
    {
        /// <summary>
        /// X-coordinate value.
        /// </summary>
        public short X { get; }

        /// <summary>
        /// Y-coordinate value.
        /// </summary>
        public short Y { get; }

        /// <summary>
        /// Z-coordinate value.
        /// </summary>
        public short Z { get; }

        public GoPoint3d16s(short x, short y, short z)
        {
            X = x;
            Y = y;
            Z = z;
        }

        public static bool operator ==(GoPoint3d16s a, GoPoint3d16s b)
        {
            return a.Equals(b);
        }

        public static bool operator !=(GoPoint3d16s a, GoPoint3d16s b)
        {
            return (!a.Equals(b));
        }

        public sealed override string ToString()
        {
            return $"{X}, {Y}, {Z}";
        }

        public override bool Equals(object obj)
        {
            return obj is GoPoint3d16s f &&
                   X == f.X &&
                   Y == f.Y &&
                   Z == f.Z;
        }

        public override int GetHashCode()
        {
            int hashCode = -307843816;
            hashCode = hashCode * -1521134295 + X.GetHashCode();
            hashCode = hashCode * -1521134295 + Y.GetHashCode();
            hashCode = hashCode * -1521134295 + Z.GetHashCode();
            return hashCode;
        }
    }
}
