/**
 * @file    GoRequestException.cs
 *
 * @internal
 * Copyright (C) 2022-2023 by LMI Technologies Inc.
 * Licensed under the MIT License.
 * Redistributed files must retain the above copyright notice.
 */
using System;

namespace GoPxLSdk
{
    public class GoRequestException : Exception
    {
        public GoRequestResponse Response { get; }

        public GoRequestException()
            : this(null) { }

        public GoRequestException(GoRequestResponse response)
            : base("GoRequestError")
        {
            Response = response;
        }
    }
}